Subject: Re: [PATCH 1/2] qemu platform, v2

From: David Gibson <[email-masked]>
Date: Mon, 1 Oct 2007 15:33:26 +1000

On Fri, Sep 28, 2007 at 06:53:28PM +0200, Segher Boessenkool wrote:
> >> I'd be following this more closely if compiling a device tree didn't 
> >> currently
> >> require an external utility (dtc or some such) that doesn't come with 
> >> the
> >> Linux kernel.  No other target platform I've built kernels for 
> >> requires such
> >> an environmental dependency.
> >
> > No?  You haven't built kernels for other platforms that have external
> > dependencies such as perl, gcc, make, binutils, etc.? :)
> 
> Two of the supported Linux archs cannot be built with a mainline
> compiler, even!
> 
> And I have to install GNU sed/awk to get builds to work, too.
> 
> OTOH, it would be nice if we didn't need DTC -- it itself doesn't
> build out-of-the-box on all systems, either ;-)
> 
> >>  (This is a problem both for hardwiring the
> >> device tree into the kernel and for building a new boot rom from the 
> >> linux
> >> kernel's ppc boot wrapper that would contain such a device tree to 
> >> feed to
> >> the kernel.)
> >
> > It's only really been a problem for ps3 so far, since the embedded
> > guys don't seem to have any difficulty with installing dtc.  We are
> > looking at what to do for ps3 and prep, and the answer may well
> > involve bundling dtc in the kernel source (it's not too big, around
> > 3400 lines).
> 
> If only a few platforms have this problem, we could instead include
> their .dtb files in the kernel source tree.

Including .dtbs in the kernel tree has a big practical problem:
they're binary, so can't be patch(1)ed, which makes updating them a
complete PITA.

I'm working on merging dtc into the kernel tree instead.

-- 
David Gibson			| I'll have my music baroque, and my code
david AT gibson.dropbear.id.au	| minimalist, thank you.  NOT _the_ _other_
				| _way_ _around_!
http://www.ozlabs.org/~dgibson